<app-loading *ngIf="isLoading"></app-loading>
<div class="form-setup-assessment">
  <form #formSearch="ngForm">
    <div nz-row [nzGutter]="[30, 10]" class="pb-10">
      <div nz-col nzSpan="6">
        <div class="mb-15">
          <label class="text-bold">
            {{
              'targerManager.targetAssessmentResults.label.table.employeeCode'
                | translate
            }}
          </label>
        </div>
        <span>{{ currentUser.empCode }}</span>
      </div>
      <div nz-col nzSpan="6">
        <div class="mb-15">
          <label class="text-bold">
            {{
              'targerManager.targetAssessmentResults.label.table.fullName'
                | translate
            }}
          </label>
        </div>
        <span>{{ currentUser.fullName }}</span>
      </div>
      <div nz-col nzXs="6" nzLg="6">
        <div class="mb-15">
          <label class="text-bold">
            {{
              'targerManager.targetAssessmentResults.label.table.periodYear'
                | translate
            }}
          </label>
        </div>
        <mb-date-picker
          name="year"
          [mbMode]="'year'"
          mbFormat="yyyy"
          mbPlaceholderText="{{
            'targerManager.targetAssessmentResults.label.table.periodYear' | translate
          }}"
          [(ngModel)]="currentYear"
          (ngModelChange)="onChangeSelectYeah($event)"
        >
        </mb-date-picker>
      </div>
      <div nz-col nzXs="6" nzLg="6">
        <div class="mb-15">
          <label class="text-bold">
            {{
              'targerManager.targetAssessmentResults.label.table.period'
                | translate
            }}
          </label>
        </div>
        <mb-select
          name="period"
          [mbShowSearch]="true"
          [mbDataSelects]="listPeriod"
          mbKeyValue="periodId"
          mbKeyLabel="periodName"
          [(ngModel)]="paramSearch.periodId"
          mbPlaceholder="{{
            'targerManager.targetAssessmentResults.label.table.period'
              | translate
          }}"
          (ngModelChange)="onChangeSelectPeriod($event)"
        >
        </mb-select>
      </div>
    </div>
  </form>
</div>

<div class="data-table-assessment" oncontextmenu="return false;">
  <nz-table
    #basicTable
    class="data-table"
    [nzData]="dataSource"
    [nzPageSize]="limit"
    [nzScroll]="{ x: '1366px', y: '500px' }"
    [nzShowPagination]="false"
    [nzWidthConfig]="listWidth"
    nzTableLayout="fixed"
    nzSize="small"
  >
    <thead>
      <tr>
        <th id="index" scope="col" class="text-center" nzLeft>
          {{ 'targerManager.targetAssessmentResults.label.table.stt' | translate }}
        </th>
        <th id="setOfIndicators" scope="col">
          {{
            'targerManager.targetAssessmentResults.label.table.setOfIndicators'
              | translate
          }}
        </th>
        <th id="position" scope="col">
          {{
            'targerManager.targetAssessmentResults.label.table.position'
              | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.setOfIndicators.label.table.asmFromDate'
            | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.setOfIndicators.label.table.asmToDate'
            | translate
          }}
        </th>
        <th id="flagStatus" scope="col" class="text-center">
          {{
            'targerManager.targetAssessmentResults.label.table.flagStatus'
              | translate
          }}
        </th>
        <th id="density" scope="col">
          {{
            'targerManager.targetAssessmentResults.label.table.density'
              | translate
          }}
          (%)
        </th>
        <th id="results" scope="col">
          {{
            'targerManager.targetAssessmentResults.label.table.results'
              | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.targetAssessmentResults.label.table.scoreX'
            | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.EvaluetionApprovalSetOfIndicator.label.plusPoint'
            | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.EvaluetionApprovalSetOfIndicator.label.minusPoint'
            | translate
          }}
        </th>
        <th scope="col" nzWidth="8%">
          {{
          'targerManager.targetAssessmentResults.label.table.pivotPointTotal'
            | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.EvaluetionApprovalSetOfIndicator.label.ratingBefore'
            | translate
          }}
        </th>
        <th scope="col">
          {{
          'targerManager.EvaluetionApprovalSetOfIndicator.label.ratingAfter'
            | translate
          }}
        </th>
        <th
          id="action"
          scope="col"
          nzRight
          class="text-center"
        >
        </th>
      </tr>
    </thead>
    <tbody>
      <tr
        (dblclick)="goToDetails(data)"
        class="tr-for-class"
        *ngFor="let data of basicTable.data; let i = index"
      >
        <td class="text-center" nzLeft>
          {{ (pageable?.currentPage - 1) * basicTable.nzPageSize + i + 1 }}
        </td>
        <td>{{ data.sotName }}</td>
        <td>{{ data.posName }}</td>
        <td>{{ data.fromDate | date: 'dd/MM/yyyy'}}</td>
        <td>{{ data.toDate | date: 'dd/MM/yyyy'}}</td>
        <td class="text-center">
          <nz-tag
            [nzColor]="'red'"
            *ngIf="data.flagStatus === listStatus.CHUA_GUI_XAC_NHAN_GIAO"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.notYetSendConfirmAssign'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.CHO_XAC_NHAN_GIAO"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.waitingSendConfirmAssign'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.CHO_PHE_DUYET_GIAO"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.waitingApproveAssign'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.HOAN_TAT_PHE_DUYET_GIAO"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.completedApproveAssign'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'red'"
            *ngIf="data.flagStatus === listStatus.CHUA_GUI_XAC_NHAN_KET_QUA"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.notYetConfirmResult'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.CHO_XAC_NHAN_KET_QUA"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.waitingConfirmResult'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.CHO_PHE_DUYET_KET_QUA"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.waitingApproveResult'
                | translate
            }}
          </nz-tag>
          <nz-tag
            [nzColor]="'blue'"
            *ngIf="data.flagStatus === listStatus.HOAN_TAT_PHE_DUYET_KET_QUA"
          >
            {{
              'targerManager.targetAssessmentResults.label.table.completedApproveResult'
                | translate
            }}
          </nz-tag>
        </td>
        <td class="text-right">{{ data.scaleNum * 100 | formatScore }}</td>
        <td class="text-right">{{ data.score | formatScore }}</td>
        <td class="text-right border-left" [rowSpan]="dataSource.length" *ngIf="!i">{{ scoreTotal | formatScore }}</td>
        <td class="text-right" [rowSpan]="dataSource.length" *ngIf="!i">{{ plusPoint | formatScore }}</td>
        <td class="text-right" [rowSpan]="dataSource.length" *ngIf="!i">{{ minusPoint | formatScore }}</td>
        <td class="text-right" [rowSpan]="dataSource.length" *ngIf="!i">{{ resultFinal | formatScore }}</td>
        <td [rowSpan]="dataSource.length" *ngIf="!i">
          {{ data?.ratingBefore }}
        </td>
        <td class="border-right" [rowSpan]="dataSource.length" *ngIf="!i">
          {{ data?.ratingAfter }}
        </td>
        <td nzRight>
          <ng-container
            *ngIf="
              data.flagStatus === listStatus.CHO_XAC_NHAN_KET_QUA &&
              objFunction?.approve
            "
          >
            <div nz-row [nzGutter]="[16, 16]">
              <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12 }">
                <mb-button
                  mbButtonType="NO_BORDER"
                  mbButtonSize="LARGE"
                  (click)="updateStatus(data, $event)"
                  mbButtonText="{{ 'targerManager.table.action.yes' | translate }}"
                  mbButtonAvailableStyle="PRIMARY"
                ></mb-button>
              </div>
              <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12}">
                <mb-button
                  mbButtonType="NO_BORDER"
                  mbButtonSize="LARGE"
                  (click)="showRejectDialog(data, $event)"
                  mbButtonText="{{ 'targerManager.table.action.no' | translate }}"
                  mbButtonAvailableStyle="PRIMARY"
                ></mb-button>
              </div>
            </div>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </nz-table>
</div>

<nz-modal
  [(nzVisible)]="isVisibleRejectDialog"
  [nzTitle]="modalTitle"
  [nzContent]="modalContent"
  [nzFooter]="modalFooter"
  [nzWidth]="500"
  (nzOnCancel)="cancelRejectDialog()"
>
  <ng-template #modalTitle>{{
    'targerManager.targetAssessmentResults.label.table.reject' | translate
  }}</ng-template>

  <ng-template #modalContent>
    <form #formReject="ngForm" nz-form>
      <ng-container *ngIf="formReject">
        <div nz-col nzXs="24" nzLg="24">
          <mb-input-text
            name="reason"
            required
            noAllowSpace
            maxlength="250"
            [mbIsTextAre]="true"
            [mbType]="
              isSubmitted &&
              (formReject.controls['reason']?.errors ||
                formReject.errors?.noAllowSpace)
                ? 'error'
                : 'default'
            "
            [mbShowError]="
              isSubmitted &&
              (formReject.controls['reason']?.errors ||
                formReject.errors?.noAllowSpace) != null
            "
            [mbErrors]="formReject.controls['reason']?.errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription:
                  'goaManagement.validate.maxLength'
                  | translate: { numberLength: '250' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'goaManagement.validate.required'
                  | translate
                    : {
                        param:
                          'targerManager.targetAssessmentResults.label.table.reasonReject'
                          | translate
                      }
              },
              {
                errorName: 'noAllowSpace',
                errorDescription:
                  'goaManagement.validate.required'
                  | translate
                    : {
                        param:
                          'targerManager.targetAssessmentResults.label.table.reasonReject'
                          | translate
                      }
              },
              {
                errorName: 'reason',
                errorDescription: 'goaManagement.validate.code' | translate
              }
            ]"
            mbPlaceholderText="{{
              'targerManager.targetAssessmentResults.label.table.inputReasonReject'
                | translate
            }}"
            mbLabelText="{{
              'targerManager.targetAssessmentResults.label.table.reasonReject'
                | translate
            }} <span class='label__required'>*</span>"
            [(ngModel)]="dataReject.reason"
          >
          </mb-input-text>
        </div>
      </ng-container>
    </form>
  </ng-template>

  <ng-template #modalFooter>
    <button nz-button nzType="default" (click)="cancelRejectDialog()">
      {{ 'common.button.cancel' | translate }}
    </button>
    <button
      nz-button
      nzType="primary"
      (click)="acceptRejectDialog()"
      [nzLoading]="isConfirmLoadingRejectDialog"
    >
      {{ 'common.button.continue' | translate }}
    </button>
  </ng-template>
</nz-modal>
